#!----------------------------------------------------------------------------------
#TEMPLATE(dcLookups, 'DinamiComp - Common Lookup Generator'),FAMILY('ABC')
#!----------------------------------------------------------------------------------
#!
#!
#SYSTEM
#DECLARE (%UModule)
#!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                               PROCEDURE EXTENSION
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!
#EXTENSION(dcGenerateLookups,'DinamiComp''s Generate Lookup Procedures-Procedure')
#!
#SHEET
#TAB('General')
    #Insert(%SETCC)
    #BOXED   ('Debugging'),Section,AT(,95,,20)
      #PROMPT  ('Disable All DinamiComp Templates',Check),%DisableAll,AT(10)
    #ENDBOXED
#ENDTAB
#TAB('Settings')
    #Insert(%SETAPP)
    #DISPLAY ('')
    #BOXED   ('Options'),AT(,65,,40)
       #DISPLAY ('')
       #DISPLAY ('Source Lookup Procedure Name')
       #PROMPT  ('',@s150),%SourceLookupProcName,AT(,,180,)
    #ENDBOXED
#ENDTAB
#TAB('Files')
    #DISPLAY ('')
    #BUTTON     ('Lookup Files...'),MULTI(%LookupFileMultiCount,%LookupFileMulti & ' : ' & %ProcedureNameMulti & ' : ' & %ScreenCaptionMulti),INLINE
       #DISPLAY ('Screen Caption')
       #PROMPT  ('',@s255),%ScreenCaptionMulti,REQ,DEFAULT(''),At(,,180,)
       #DISPLAY ('Select Lookup File.')
       #PROMPT  ('',FILE),%LookupFileMulti,REQ,WHENACCEPTED(%StripExclamation(%LookupFileMulti))
       #DISPLAY ('Select lookup numeric key')
       #PROMPT  ('',KEY),%LookupNumericKeyMulti,REQ,AT(,,150,)
       #DISPLAY ('Select lookup alphabetic key')
       #PROMPT  ('',KEY),%LookupAlphabeticKeyMulti,REQ,AT(,,150,)
       #DISPLAY ('Select Lookup field 1 (AutoNumber)')
       #PROMPT  ('',FIELD),%LookupFieldIDMulti1,REQ,WHENACCEPTED(%StripExclamation(%LookupFieldIDMulti1))
       #DISPLAY ('Select Lookup field 2 (Description)')
       #PROMPT  ('',FIELD),%LookupFieldIDMulti2,REQ,WHENACCEPTED(%StripExclamation(%LookupFieldIDMulti2))
       #DISPLAY ('Procedure Name')
       #PROMPT  ('',@s255),%ProcedureNameMulti,Default('Browse'),REQ,At(,,180,)
    #ENDBUTTON
#ENDTAB
#ENDSHEET

#!------------------------------------------------------------------------------------------------------------------------
#! Add the procedures to the map
#!------------------------------------------------------------------------------------------------------------------------
#AT(%GlobalMap)
#IF(%DisableAll=%False)
#SET(%UModule,UPPER(%Module))
MODULE('%UModule')
  #INDENT(-5)
  #FOR(%LookupFileMultiCount)
    #SET(%ValueConstruct,%ProcedureNameMulti)
%[32]ValueConstruct PROCEDURE
  #ENDFOR
  #INDENT(5)
END
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------                                    
#! Add the procedures to the export list
#!------------------------------------------------------------------------------------------------------------------------
#AT(%DLLExportList)
#IF(%DisableAll=%False)
  #FOR(%LookupFileMultiCount)
    #SET(%ValueConstruct,%ProcedureNameMulti & '@F')
  %[55]ValueConstruct @?
  #ENDFOR
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#! Generate the Browse:LookupFile procedures
#!------------------------------------------------------------------------------------------------------------------------
#AT(%ProcessedCode),PRIORITY(7500)
#IF(%DisableAll=%False)
#FOR(%LookupFileMultiCount)
#!---------------------------------------------------------------------------
%ProcedureNameMulti    PROCEDURE                        ! Declare Procedure
!----------------------------------------------------------------------------
szCaption   CString(256)
szProcName  CString(256)
View:Browse View(%LookupFileMulti)
               Project(%LookupFieldIDMulti1)
               Project(%LookupFieldIDMulti2)
            END

  CODE
  szCaption   = '%ScreenCaptionMulti'
  szProcName  = '%ProcedureNameMulti'
  %SourceLookupProcName(szCaption,  View:Browse, Relate:%LookupFileMulti, %LookupNumericKeyMulti, %LookupAlphabeticKeyMulti, |
                     %LookupFieldIDMulti1, %LookupFieldIDMulti2, szProcName)
  RETURN

#ENDFOR
#ENDIF
#ENDAT

#!------------------------------------------------------------------------------------------------------------------------
#GROUP(%SETCC)
#!-----------------------------------------------------------------------------------------------------
#BOXED('DinamiComp Template Set'),SECTION,AT(,10,,65)
  #DISPLAY ('')
  #DISPLAY ('DinamiComp CC Lookup Template Set for Clarion 6.3')
  #DISPLAY ('Copyright 2002 All Rights Reserved WorldWide.')
  #DISPLAY ('')
  #DISPLAY ('Version 1.0')
#ENDBOXED

#!-----------------------------------------------------------------------------------------------------
#GROUP(%SETAPP)
#!-----------------------------------------------------------------------------------------------------
#BOXED('DinamiComp Lookup Templates'),SECTION,AT(,10,,45)
  #DISPLAY ('')
  #DISPLAY ('Automatic Lookup-File Procedure Creation')
  #DISPLAY ('')
#ENDBOXED

#!-----------------------------------------------------------------------------------------------------
#GROUP (%StripExclamation,*%zField)
#!-----------------------------------------------------------------------------------------------------
  #IF(SUB(%zField,1,1)='!')
    #SET(%zField,SUB(%zField,2,LEN(%zField)-1))
  #ENDIF

#!
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!                                               PROCEDURE EXTENSION
#!@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#!
#EXTENSION(dcGenerateLookupProcCalls,'DinamiComp''s Call Lookup Procedures-Procedure')
#!
#! Create list of lookup files (only 5 fields)
#SHEET
#TAB('General')
    #Insert(%SETCC)
    #BOXED   ('Debugging'),Section,AT(,95,,20)
      #PROMPT  ('Disable All DinamiComp Templates',Check),%DisableAll,AT(10)
    #ENDBOXED
#ENDTAB
#TAB('Settings')
    #Insert(%SETAPP)
#ENDTAB
#TAB('Files')
    #DISPLAY ('')
    #BUTTON     ('Lookup Files...'),MULTI(%LookupFileMultiCountP,%LookupFileMultiP & ' : ' & %ProcedureNameMultiP),INLINE
       #DISPLAY ('Select Lookup File.')
       #PROMPT  ('',FILE),%LookupFileMultiP,REQ,WHENACCEPTED(%StripExclamation(%LookupFileMultiP))
       #DISPLAY ('Procedure Name')
       #PROMPT  ('',@s255),%ProcedureNameMultiP,REQ,DEFAULT('Browse'),At(,,180,)
    #ENDBUTTON
#ENDTAB
#ENDSHEET

#AT(%LocalDataAfterClasses),PRIORITY(8500)
TreeMenu    Class()
ProcedureString     String(255)
   #EMBED(%DINLookUpClass1,'DinamiComp - Loookup Class: Class Definition - Before Methods')
RUNProc     Procedure
   #EMBED(%DINLookUpClass2,'DinamiComp - Loookup Class: Class Definition - After Methods')
            End
#ENDAT

#At(%LocalProcedures),Description('DinamiComp(Local) - Procedures')


TreeMenu.RunProc Procedure
  Code
  Case Self.ProcedureString
  #FOR(%LookupFileMultiCountP)
  Of '%ProcedureNameMultiP'
     Start(%ProcedureNameMultiP)
  #ENDFOR
  End  !End Case

#ENDAT